# Useful RAIDs with ZFS
**R**edundant **A**rray of **I**ndependent **D**isks

## ROADMAP
- [x] RAID{10,1,6,10}
- [ ] RAID implementations in ZFS
- [ ] Cache systems in ZFS
___

- [ ] ZFS for DB or lvm+ext4

## Some recorrent terms when defining a RAID system:
**PARITY** 
:   Refers to *parity bit*, it's a bit added to a string that says if the sum of bits in the string is even/odd, it's a simple form of error checking. Commonly the parity bit is added in the end of each byte (8 bits).

**DATA STRIPING**
:   The concept of dividing each data array into various segments so the data can be more easily manipulated and stored

**MIRROR**
:   Replicates *logical disk* volumes into multiple fisical disks, so the same information is stored in different hard disks in real time
    
## RAID0
![RAID0 diagram](./imgs/RAID0.png)

RAID0 splits data across a multiple-disks array. The ideal setup is equaly-sized disks since the total storage used in a RAID0 arrangement is equal to the lower storage disk space times the total amount of disks. I a array of one 120Gb disk and one 360Gb disk, the total storage available would be 240 Gb.

RAID0 create stripes of data so disk operations are n-times faster, n being the total amount of disks available. It also distributes I/O costs between all disks making it a very fast storage system. RAID0 **doesn't implements parity** or even any **fault tolerance**, so the failure of one single disk in the array will result in total data loss. 

Besides fastness, RAID0 also is a good system to create large amounts of data storage units with lesser disks, since all disks in the array have unique information and, having equaly-sized units, uses 100% it's fisical capability as storage.

## RAID1
![RAID1 diagram](./imgs/RAID1.png)

RAID1 mirrors sets of data on **two or more** fisical disks at a time. This RAID setting, as in RAID0, also doesn't offer any *parity* and the setup replicates the size of the smallest disk on all the other disks as well. In RAID1 theres no data striping since all data is replicated multiple times.

RAID1 read operations can be taken by any of the disks in the array, it's useful on read performance and reliability on data, but it is bad on write performance and total data storage capacity. 

## RAID6
![RAID6 diagram](./imgs/RAID6.png)

RAID6 uses *double parity* striped all over the array so it's allways possible to have two failed disks without losing any information. It needs to calculate 2 different systems to make paritys p and q and store them in distinct units, because of this, RAID6 has a overhead cost on write operations that is the double of a single-parity implementation as in RAID5. RAID5 doesn't have read operations performance penaltys.

RAID6 is a very good system to use when reliability and disponibility of data is more needed than performance.

## RAID10
![RAID10 diagram](./imgs/RAID10.png)

RAID10 is a simuntaneous implementation of RAID0 and RAID1, combining the performance boost of RAID0 with the reliability of data present in RAID1. RAID10 needs at least two 'tanks' of disks arranged in RAID1 configuration, replicating all data in all disks of each tank. Than it takes these tanks and arrange then in a RAID0 setup, so all data is striped and writen segmented in each tank.

RAID10 offers a boost in read and write operations performance, at the same time that it permits at least 1 disk of each tank failing at once without any data loss. This systems does this by using double of logical storage in fisical storage, so it'll always use half of total raw disks capacity.

It's a good system when total storage isn't more requested than performance and relaibility.
